Bug 99284

Summary: openoffice.org-2.0 fails on current because of the addition of gethostbyname_r to libc
Product: Ports & Packages Reporter: NAKAJI Hiroyuki <nakaji>
Component: Individual Port(s)Assignee: freebsd-openoffice (Nobody) <openoffice>
Status: Closed FIXED    
Severity: Affects Only Me CC: maho
Priority: Normal    
Version: Latest   
Hardware: Any   
OS: Any   
Attachments:
Description Flags
file.diff none

Description NAKAJI Hiroyuki 2006-06-22 01:10:22 UTC
	As Diane Bruce reported to openoffice@freebsd.org,
(http://lists.freebsd.org/pipermail/freebsd-openoffice/2006-June/002457.html)
on 7.0-current after 700016, editors/openoffice.org-2.0 fails to build
with following error.

gmake[5]: Entering directory `/usr/ports/editors/openoffice.org-2.0/work/OOB680_m5/moz/unxfbsd.pro/misc/build/mozilla/nsprpub/pr/src/misc'
gcc-ooo -o prnetdb.o -c     -pipe  -ansi -Wall -O -fPIC  -UDEBUG -DMOZILLA_CLIENT=1 -DNDEBUG=1 -DXP_UNIX=1 -DFREEBSD=1 -DHAVE_BSD_FLOCK=1 -DHAVE_SOCKLEN_T=1 -DHAVE_LCHOWN=1 -DHAVE_STRERROR=1 -D_REENTRANT=1 -D_THREAD_SAFE=1  -DFORCE_PR_LOG -D_PR_PTHREADS -UHAVE_CVAR_BUILT_ON_SEM -D_NSPR_BUILD_ -I/usr/ports/editors/openoffice.org-2.0/work/OOB680_m5/moz/unxfbsd.pro/misc/build/mozilla/dist/include/nspr -I../../../pr/include -I../../../pr/include/private  prnetdb.c
prnetdb.c:1180: error: conflicting types for 'getprotobyname_r'
/usr/include/netdb.h:250: error: previous declaration of 'getprotobyname_r' was here
prnetdb.c:1180: error: conflicting types for 'getprotobyname_r'
/usr/include/netdb.h:250: error: previous declaration of 'getprotobyname_r' was here
prnetdb.c:1189: error: conflicting types for 'getprotobynumber_r'
/usr/include/netdb.h:253: error: previous declaration of 'getprotobynumber_r' was here
prnetdb.c:1189: error: conflicting types for 'getprotobynumber_r'
/usr/include/netdb.h:253: error: previous declaration of 'getprotobynumber_r' was here
gmake[5]: *** [prnetdb.o] Error 1
gmake[5]: Leaving directory `/usr/ports/editors/openoffice.org-2.0/work/OOB680_m5/moz/unxfbsd.pro/misc/build/mozilla/nsprpub/pr/src/misc'

Fix: I added to files/patch-i65512 the diff which Diane reported.

Stephane E. Potvin showed another diff, I'm not sure which is better.
(http://lists.freebsd.org/pipermail/freebsd-openoffice/2006-May/002414.html)
How-To-Repeat: 	cd /usr/ports/editors/openoffice.org-2.0
	make
Comment 1 Edwin Groothuis freebsd_committer 2006-06-22 02:52:58 UTC
Responsible Changed
From-To: freebsd-ports-bugs->openoffice

Over to maintainer
Comment 2 NAKAJI Hiroyuki 2006-06-25 03:45:16 UTC
I found another build error; the diff I sent for gethostbyname_r() is
not sufficient. So I give up this PR. The problem seems to be in
libpthread.

The error occurs on recent current like this.

Checking DLL ../../../unxfbsdi.pro/lib/check_libmozabdrv2.so ...Fatal error 'Spinlock called when not threaded.' at line 91 in file /usr/src/lib/libpthread/thread/thr_spinlock.c (errno = 2)
Abort trap (core dumped)
dmake:  Error code 1, while making '../../../unxfbsdi.pro/lib/libmozabdrv2.so'
'---* tg_merge.mk *---'

ERROR: Error 65280 occurred while making /usr/ports/editors/openoffice.org-2.0/work/OOC680_m5/connectivity/source/drivers/mozab
dmake:  Error code 1, while making 'build_instsetoo_native'
'---* *---'
*** Error code 255

Stop in /usr/ports/editors/openoffice.org-2.0.

My thr_spinlock.c is Rev. 1.24.
-- 
NAKAJI Hiroyuki
Comment 3 NAKAJI Hiroyuki 2006-07-06 00:42:39 UTC
Success!

I had to remove /usr/lib/libc_r.* which causes c++'s -pedantic bug.

After removing them, "portupgrade ja-openoffice.org" was successful with
this patch (I had already sent).

Index: files/patch-i65512
===================================================================
RCS file: /home/ncvs/ports/editors/openoffice.org-2.0/files/patch-i65512,v
retrieving revision 1.2
diff -u -r1.2 patch-i65512
--- files/patch-i65512	3 Jun 2006 11:39:21 -0000	1.2
+++ files/patch-i65512	21 Jun 2006 23:46:36 -0000
@@ -41,3 +41,21 @@
  #endif
  
  #endif /* __OSL_SYSTEM_H__ */
+--- moz/mozilla-source-1.7.5.patch.orig	Wed Jun 21 23:50:14 2006
++++ moz/mozilla-source-1.7.5.patch	Thu Jun 22 00:00:08 2006
+@@ -7697,3 +7697,15 @@
+   
+   # Force applications to be built non-statically
+   # when building the mozcomps meta component
++--- misc/build/mozilla/nsprpub/pr/src/misc/prnetdb.c.orig	Thu Sep  2 08:44:37 2004
+++++ misc/build/mozilla/nsprpub/pr/src/misc/prnetdb.c	Wed Jun 21 23:58:12 2006
++@@ -105,7 +105,8 @@
++ #define _PR_HAVE_GETPROTO_R_INT
++ #endif
++ 
++-#if (defined(LINUX) && defined(__GLIBC__) && __GLIBC__ >= 2)
+++#if (defined(LINUX) && defined(__GLIBC__) && __GLIBC__ >= 2) || \
+++	(defined(__FreeBSD__) && __FreeBSD_version > 700016)
++ #define _PR_HAVE_GETPROTO_R
++ #define _PR_HAVE_5_ARG_GETPROTO_R
++ #endif

Note: I sent JCA to OOo, and I'm waiting I'll be listed.
-- 
NAKAJI Hiroyuki
Comment 4 Maho Nakata freebsd_committer 2006-07-06 04:08:24 UTC
State Changed
From-To: open->closed

Committed, thanks!